\documentclass[11pt, oneside]{book} % TODO add 'final' option if document is complete
\usepackage[a4paper,
            width=150mm,
            top=35mm,
            bottom=25mm,
            bindingoffset=10mm,
            headheight=5mm,
            headsep=10mm,
            footskip=10mm]{geometry}
\usepackage[backend=biber, sorting=none, maxcitenames=2, maxbibnames=25]{biblatex}
\usepackage[ngerman, american]{babel}
\usepackage{setspace}
\usepackage{fancyhdr}
\usepackage[pdfusetitle, hidelinks, pdfcreator={TeX}]{hyperref}
\usepackage{csquotes}
\usepackage{unicode-math}
\usepackage{amsmath}
\usepackage{algorithm}
\usepackage{algpseudocodex}
\usepackage{graphicx}
\usepackage{parskip}
\usepackage{titlesec}
\usepackage{color}
\usepackage{tikzpagenodes}
\usepackage{bookmark}
\usepackage{siunitx}
\usepackage{etoolbox}
\usepackage{comment}
\usepackage{booktabs}
\usepackage{tabularx}
\usepackage{letltxmacro}
\usepackage[all]{nowidow}
\usepackage[final]{microtype}
\usepackage[nottoc]{tocbibind}
\usepackage[shortcuts]{extdash}
\usepackage[obeyFinal]{todonotes}
\usepackage[nodayofweek]{datetime}
\usepackage[skip=5pt]{subcaption}
\usepackage[capitalize, nameinlink, noabbrev]{cleveref}
\usepackage[format=hang, font={color=darkgray}, skip=5pt]{caption}
\usepackage[nonumberlist, nogroupskip, shortcuts=ac]{glossaries-extra}

% graphics directory
\graphicspath{{graphics/}}

% bibtex references
\addbibresource{resource/references.bib}

% acronyms and glossary
\makenoidxglossaries
\setabbreviationstyle[acronym]{short-long}
\loadglsentries{resource/acronyms.tex}
\glssetwidest{RWTH\quad} % TODO adjust for widest entry or use \glsfindwidesttoplevelname
\setglossarystyle{alttree}
\renewcommand{\glossarypreamble}{\setlength{\parskip}{0pt}}
\LetLtxMacro{\oldglsxtrlong}{\glsxtrlong}
\LetLtxMacro{\oldGlsxtrlong}{\Glsxtrlong}
\LetLtxMacro{\oldglsxtrlongpl}{\glsxtrlongpl}
\LetLtxMacro{\oldGlsxtrlongpl}{\Glsxtrlongpl}
\renewcommand{\glsxtrlong}[2][hyper=false]{\oldglsxtrlong[#1]{#2}}
\renewcommand{\Glsxtrlong}[2][hyper=false]{\oldGlsxtrlong[#1]{#2}}
\renewcommand{\glsxtrlongpl}[2][hyper=false]{\oldglsxtrlongpl[#1]{#2}}
\renewcommand{\Glsxtrlongpl}[2][hyper=false]{\oldGlsxtrlongpl[#1]{#2}}

% fonts and line spacing
\setmainfont{Cambria}[
  Extension=.ttf,
  Path=./fonts/,
  UprightFont={*},
  BoldFont={*-Bold},
  ItalicFont={*-Italic},
  BoldItalicFont={*-BoldItalic}
]
\setmathfont{Cambria-Math}[
  Extension=.ttf,
  Path=./fonts/
]
\setmonofont{SourceCodePro}[
  Extension=.ttf,
  Path=./fonts/,
  UprightFont={*},
  BoldFont={*-Bold},
  ItalicFont={*-Italic},
  BoldItalicFont={*-BoldItalic}
]
\setstretch{1.25}

% page layout
\pagestyle{fancy}
\fancyhf{}
\fancyhead[R]{\nouppercase{
  \ifnum \value{chapter}>0 \thechapter \fi
  \enskip\leftmark
}}
\fancyfoot[R]{\thepage}
\fancypagestyle{plain}{
  \fancyhf{}
  \fancyfoot[R]{\thepage}
  \renewcommand{\headrulewidth}{0pt}
}
\renewcommand{\chaptermark}[1]{\markboth{#1}{}}

% chapter and section layout
\titlespacing*{\chapter}{0pt}{0pt}{1cm}
\titleformat{\chapter}[hang]{\huge\bf}{\thechapter}{1em}{\huge}
\titleformat{\section}[hang]{\Large\bf}{\thesection}{1em}{\Large}
\titleformat{\subsection}[hang]{\large\bf}{\thesubsection}{1em}{\large}
\titleformat{\subsubsection}[hang]{}{}{}{\bf}

% todonotes layout
\reversemarginpar
\setuptodonotes{
  size=\footnotesize,
  backgroundcolor=white,
  linecolor=gray,
  bordercolor=gray,
  tickmarkheight=5pt
}
\let\TODO\todo

% custom hyperlink
\makeatletter
\newcommand{\htarget}[2]{\hypertarget{#1}{#2}%
  \protected@write\@mainaux{}{%
    \string\expandafter\string\gdef
    \string\csname\string\detokenize{#1}\string\endcsname{#2}%
  }%
}
\newcommand{\hlink}[1]{(\hyperlink{#1}{\csname #1\endcsname})}
\newcommand{\hlinks}[1]{\hyperlink{#1}{\csname #1\endcsname}}
\makeatother

% algorithm settings
\algrenewcommand\alglinenumber[1]{\footnotesize #1}

% SI units settings
\sisetup{detect-all=true}
\robustify\bfseries
